!***********************************************************************
!*   
!*   Licensed Materials - Property of IBM.
!*   IBM XL Fortran Advanced Edition for Blue Gene/P, V11.1
!*   (5799-HJF)
!*   Copyright IBM Corp. 2003, 2007.
!*   All Rights Reserved.
!*   US Government Users Restricted Rights - 
!*   Use, duplication or disclosure restricted by 
!*   GSA ADP Schedule Contract with IBM Corp.
!*
!***********************************************************************

@process extname
      module xlfutility_extname
!
!
! Note: If this file is to be used for the 64-bit mode, the definition of
! TIME_SIZE should be changed to:
!
!       integer(4), parameter :: TIME_SIZE = 8
!
        integer(4), parameter :: TIME_SIZE = 4
        type iar
          sequence
          integer(4) ihr
          integer(4) imin
          integer(4) isec
        end type

        type idate_type
          sequence
          integer(4) iday
          integer(4) imonth
          integer(4) iyear
        end type

        type tb_type
          sequence
          real(4) usrtime
          real(4) systime
        end type

        interface
          integer(4) function alarm(time, func)
            integer(4), intent(in) ::  time
            integeR(4) func
          end function alarm

          subroutine bic(x1,x2)
           integer(4), intent(in) :: x1
            integer(4), intent(inout) :: x2
          end subroutine bic

          subroutine bis(x1,x2)
            integer(4), intent(in) :: x1
            integer(4), intent(inout) :: x2
          end subroutine bis

          logical(4) function bit(x1,x2)
            integer(4), intent(in) :: x1
            integer(4), intent(in) :: x2
          end function bit

          character(8) function clock()
          end function clock

          subroutine ctime(str, time)
            import TIME_SIZE
            character(*), intent(out) :: str
            integer(kind=TIME_SIZE), intent(in) :: time
          end subroutine ctime

          character(8) function date()
          end function date

          real(4) function dtime(dtime_struct)
            import tb_type
            type(tb_type), intent(out) :: dtime_struct
          end function dtime

          real(4) function etime(etime_struct)
            import tb_type
            type(tb_type), intent(out) :: etime_struct
          end function etime

          subroutine exit(exit_status)
            integer(4), intent(in) :: exit_status
          end subroutine exit

          subroutine fdate(str)
            character(*), intent(out) :: str
          end subroutine fdate

          subroutine flush(lunit)
            integer(4), intent(in) :: lunit
          end subroutine flush

          subroutine fpgets(fpstat)
            logical(4), intent(out) :: fpstat(32)
          end subroutine fpgets

          subroutine fpsets(fpstat)
            logical(4), intent(in) :: fpstat(32)
          end subroutine fpsets

          subroutine getarg(i1,c1)
            integer(4), intent(in) :: i1
            character(*), intent(out) :: c1
          end subroutine getarg

          integer(4) function getcwd(name)
            character(*), intent(out) :: name
          end function getcwd

          integer(4) function getfd(lunit)
            integer(4), intent(in) :: lunit
          end function getfd

          integer(4) function getgid()
          end function getgid

          subroutine getlog(name)
            character(*), intent(out) :: name
          end subroutine getlog

          integer(4) function getpid()
          end function getpid

          integer(4) function getuid()
          end function getuid

          subroutine gmtime(stime, tarray)
            import TIME_SIZE
            integer(kind=TIME_SIZE), intent(in) :: stime
            integer(4), intent(out) :: tarray(9)
          end subroutine gmtime

          integer(4) function hostnm(name)
           character(*), intent(out) :: name
          end function hostnm

          integer(4) function iargc()
          end function iargc

          subroutine idate(idate_struct)
            import idate_type
            type(idate_type), intent(out) :: idate_struct
          end subroutine idate

          integer(4) function ierrno()
          end function ierrno

          integer(4) function irand()
          end function irand

          integer(8) function irtc()
          end function irtc

          subroutine itime(itime_struct)
            import iar
            type(iar), intent(out) :: itime_struct
          end subroutine itime

          character(8) function jdate()
          end function jdate

          integer(4) function lenchr(str)
            character(*), intent(in) :: str
          end function lenchr

          integer(4) function lnblnk(str)
            character(*), intent(in) :: str
          end function lnblnk

          subroutine ltime(stime, tarray)
            import TIME_SIZE
            integer(kind=TIME_SIZE), intent(in) :: stime
            integer(4), intent(out) :: tarray(9)
          end subroutine ltime

          integer(4) function mclock()
          end function mclock

          real(8) function rtc()
          end function rtc

          subroutine setrteopts(c1)
            character(*), intent(in) :: c1
          end subroutine setrteopts

          subroutine sleep(sec)
            integer(4), intent(in) :: sec
          end subroutine sleep

          real(8) function timef()
          end function timef

          function time()
            import TIME_SIZE
            integer(kind=TIME_SIZE) time
          end function time

          integer(4) function umask(cmask)
            integer(4), intent(in) :: cmask
          end function umask

          integer(4) function usleep(msec)
            integer(4), intent(in) :: msec
          end function usleep

          integer(4) function ftell(lunit)
            integer(4), intent(in) :: lunit
          end function ftell

          integer(8) function ftell64(lunit)
            integer(4), intent(in) :: lunit
          end function ftell64

        end interface

      end module
